Unit My_Graph;

Interface

Uses graph;

Type
  user_pal=array[0..255,1..3] of byte;
  pcxbuffer=array[1..64010] of byte;
  pcxheder=record
        manuf:byte;                  {/* ᥣ =10  Paintbrush     */}
        hard :byte;                  {/* ଠ  ᨨ           */}
        encod:byte;                  {/* 㯯 ஢(=1)     */}
        bitpx:byte;                  {/*   (1,2,4,8,         */}
        x1,y1,x2,y2:word;            {/*  ⨭(.)    */}
    hres,vres:word;                  {/* 襭 ᯫ            */}
        clrma:array[1..48] of byte;  {/*                        */}
        vmode:byte;                 {/* ()                */}
      nplanes:byte;                  {/* - ᪮⥩ (.2.5=0) */}
        bplin:word;                  {/*   ப                */}
      palinfo:word;                  {/* .  (1=.,2=)*/}
  shres,svres:word;                  {/* 襭 ᪠           */}
         xtra:array[1..54] of byte;  {/* .⮥  (䨫)     */}
  end;
  Procedure SetRGBPal(i,r,g,b:Byte);
  Procedure fpcx8scr(s:string; i0,j0,kp:integer; var pl:user_pal);

implementation

Procedure SetRGBPal(i,r,g,b:Byte);
begin
  Port[$3C8]:=i;
  Port[$3C9]:=r;
  Port[$3C9]:=g;
  Port[$3C9]:=b;
end;

procedure fpcx8scr(s:string;i0,j0,kp:integer; var pl:user_pal);
var
    f:file;
    h:pcxheder;
    kl,lf:longint;
    p:user_pal;
    lh,lv,ls,i,j,k:word;
    kb,nb,b:byte;
    im:^pcxbuffer;
    him:array[1..2] of word;
    ksmax,ks,jt,li:word;
    buf:array[1..1024] of byte;
    ntb:integer;

  function readbyte(k:integer):byte;
  var l:longint;
      lw:word;
  begin
    if k=0 then
      begin
        ntb:=ntb+1;
        if ntb>1024 then
          begin
            l:=lf-filepos(f); if l>=1024 then lw:=1024 else lw:=l;
            blockread(f,buf,lw); ntb:=1;
          end;
        readbyte:=buf[ntb];
      end
    else
      begin
        l:=lf-filepos(f); if l>=1024 then lw:=1024 else lw:=l;
        blockread(f,buf,lw); ntb:=128;
      end;
  end;
begin
{header}
 assign(f,s); reset(f,1);
 lf:=filesize(f); blockread(f,h,sizeof(h));
 lh:=h.x2-h.x1+1; lv:=h.y2-h.y1+1;
{pal}
 if kp<>0 then
   begin
     kl:=lf-768; seek(f,kl-1); blockread(f,b,1);
     blockread(f,p,768);
     for k:=1 to 255 do
       begin
         if b=12 then
           begin
             p[k,1]:=(p[k,1] shr 2);
             p[k,2]:=(p[k,2] shr 2);
             p[k,3]:=(p[k,3] shr 2);
           end;
         setrgbpal(k,p[k,1],p[k,2],p[k,3]);
       end;
     pl:=p;
   end;
{image}
 seek(f,0); b:=readbyte(1);
 new(im);
 ksmax:=1; him[1]:=lh-1; him[2]:=ksmax-1; move(him,im^,4);
 li:=5; ls:=0; ks:=0; jt:=j0;
 k:=0; while k<lv do
   begin
     b:=readbyte(0);kb:=b shr 6; nb:=1;
     if kb=3 then begin nb:=(b and 63); b:=readbyte(0); end;
     fillchar(im^[li],nb,b); li:=li+nb; ls:=ls+nb;
     if ls>=lh then
       begin
         k:=k+1; ks:=ks+1; ls:=ls-lh;
         if ks=ksmax then
           begin
             putimage(i0,jt,im^,0);
             if ls<>0 then fillchar(im^[5],ls,b);
             li:=5+ls; ks:=0; jt:=jt+ksmax;
           end;
       end;
   end;
   if ks<>0 then
     begin
       him[2]:=ks-1; move(him,im^,4); putimage(i0,jt,im^,0);
     end;
 dispose(im);
 close(f);
end;

END.