unit My_Mouse;
Interface
uses dos;
Type
    TMouse = Object
      r:registers;
      ok:Boolean;
      Constructor Init;
      Procedure Show;
      Procedure Hide;
      Procedure SetPos(x,y:integer);
      Procedure MovePos(var x,y:integer);
      Procedure XYBut(var x,y,but:integer);
    End;
PROCEDURE SetLimits(xtop,ytop,xbottom,ybottom:WORD);

Implementation

PROCEDURE SetLimits(xtop,ytop,xbottom,ybottom:WORD);ASSEMBLER;
ASM
        { set horizontal limits }
        MOV     AX,0007h
        MOV     CX,[xtop]
        MOV     DX,[xbottom]
        INT     33h
        { set vertical limits }
        MOV     AX,0008h
        MOV     CX,[ytop]
        MOV     DX,[ybottom]
        INT     33h
END;

Constructor TMouse.Init;
Begin
    r.ax := 0;
    Intr($33,r);
    If r.ax <> 0 then ok := true
     Else ok := false;
End;

Procedure TMouse.Show;
Begin
    If ok then
       Begin
         r.ax := 1;
         Intr($33,r);
      End;
End;

Procedure TMouse.Hide;
Begin
    If ok then
       Begin
         r.ax := 2;
         Intr($33,r);
       End;
End;

Procedure TMouse.SetPos;
Begin
    If ok then
       Begin
         r.ax := 4;
         r.cx := x;
         r.dx := y;
         Intr($33,r);
       End;
End;

Procedure TMouse.MovePos;
Begin
    If ok then
       Begin
         r.ax := 11;
         Intr($33,r);
         x := r.cx;
         y := r.dx;
       End;
End;
Procedure TMouse.XYBut;
Begin
    If ok then
       Begin
         r.ax := 3;
         Intr($33,r);
         x   := r.cx;
         y   := r.dx;
         but := r.bx;
       End;
End;
end.