Unit Int_Tpu;
Interface
Uses Graph,Crt,Types;
Type Point=record
             x,y,z:Integer;
           End;
var Xmin,Xmax:array[0..600] of integer;
    Ymin,Ymax:integer;

Procedure Int_Treug(x1,y1,i1,x2,y2,i2,x3,y3,i3:integer);
Procedure Int_4Ug(x1,y1,i1,x2,y2,i2,x3,y3,i3,x4,y4,i4:Integer);
Procedure Int_DiTreug(x1,y1,i11,i12,x2,y2,i21,i22,x3,y3,i31,i32:integer);
Procedure Int_Di4Ug(x1,y1,i11,i12,x2,y2,i21,i22,x3,y3,i31,i32,x4,y4,i41,i42:Integer);

Implementation

Function Min(y1,y2,y3:integer):integer;
var minn: integer;
begin
  minn:=y1;
  if y2<minn then minn:=y2;
  if y3<minn then minn:=y3;
  Min:=minn;
end;

Function Max(y1,y2,y3:integer):integer;
var maxx:integer;
begin
  maxx:=y1;
  if y2>maxx then maxx:=y2;
  if y3>maxx then maxx:=y3;
  Max:=maxx;
end;

Procedure Normal(var A,B,C,D:real;x1,y1,n1,x2,y2,n2,x3,y3,n3:integer);
var xt,yt,zt,
    xt1,yt1,zt1:real;
Begin
  xt:=(x1-x2);
  yt:=(y1-y2);
  zt:=(n1-n2);
  xt1:=(x1-x3);
  yt1:=(y1-y3);
  zt1:=(n1-n3);
  A:=(yt*zt1-zt*yt1);
  B:=(zt*xt1-xt*zt1);
  C:=(xt*yt1-xt1*yt);
  If C=0 then c:=1;
  D:=-(A*(x1)+B*(y1)+C*(n1));
End;

Procedure Points(x,i:integer);
begin
  If (i<0) or (i>600) then exit;
  if x<xmin[i] then xmin[i]:=x;
  if x>xmax[i] then xmax[i]:=x
end;

Procedure Scan(x1,y1,x2,y2:integer);
var x,y,k:integer;
Begin
  if y1>y2 then
    begin
      k:=x1;x1:=x2;x2:=k;
      k:=y1;y1:=y2;y2:=k
    end;
  If (y1=y2) then
    Begin
      Points(x1,y1);
      Points(x2,y2);
      Exit;
    end;
  For y:=y1 to y2 do
    Begin
      x:=Trunc(((y-y1)*(x2-x1))/(y2-y1)+x1);
      Points(x,y);
    End;
End;

Procedure Int_Treug(x1,y1,i1,x2,y2,i2,x3,y3,i3:integer);
var ar,br,dr,cr:real;
    i,k,Ki:integer;
Begin
  For i:=0 to 600 do
     Begin
       XMin[i]:=1000;
       XMax[i]:=-1000;
     End;
  YMin:=min(y1,y2,y3);
  YMax:=max(y1,y2,y3);
  If YMin<0 then YMin:=0;
  If YMax>500 then Ymax:=500;
  Scan(x1,y1,x2,y2);
  Scan(x1,y1,x3,y3);
  Scan(x2,y2,x3,y3);
  Normal(ar,br,cr,dr,x1,y1,i1,x2,y2,i2,x3,y3,i3);
  For i:=ymin to ymax do
    For k:=xmin[i] to xmax[i] do
      begin
        Ki:=(round(-(Ar*k+Br*i+Dr)/Cr));
        Ki:=Ki+Random(Smoot)-Trunc(Smoot/2);
        If Ki<1 then Ki:=1;
        If Ki>240 then Ki:=240;
        PutPixel(k,i,Ki);
      end;
End;

Procedure Int_4Ug(x1,y1,i1,x2,y2,i2,x3,y3,i3,x4,y4,i4:Integer);
Begin
  If i2=i3 then
    Begin
      i1:=i1 xor i2;i2:=i1 xor i2;i1:=i1 xor i2;
      i1:=i1 xor i3;i3:=i1 xor i3;i1:=i1 xor i3;
      i3:=i3 xor i4;i4:=i3 xor i4;i3:=i3 xor i4;
      y1:=y1 xor y2;y2:=y1 xor y2;y1:=y1 xor y2;
      y1:=y1 xor y3;y3:=y1 xor y3;y1:=y1 xor y3;
      y3:=y3 xor y4;y4:=y3 xor y4;y3:=y3 xor y4;
      x1:=x1 xor x2;x2:=x1 xor x2;x1:=x1 xor x2;
      x1:=x1 xor x3;x3:=x1 xor x3;x1:=x1 xor x3;
      x3:=x3 xor x4;x4:=x3 xor x4;x3:=x3 xor x4;
    End;
  If SetkaIn3D then Int_Treug(x2,y2,i2,x3,y3,i3,x4,y4,i4);
  IF Setka then
    Begin
      SetColor(242);
      Line(x4,y4,x2,y2);
      Line(x3,y3,x4,y4);
    End;
  If SetkaIn3D then Int_Treug(x1,y1,i1,x2,y2,i2,x3,y3,i3);
  IF Setka then
    Begin
      SetColor(242);
      Line(x1,y1,x2,y2);
      Line(x3,y3,x1,y1);
    End;
End;

Procedure Int_DiTreug(x1,y1,i11,i12,x2,y2,i21,i22,x3,y3,i31,i32:integer);
var ar1,br1,dr1,cr1,ar2,br2,dr2,cr2:real;
    i,k,Ki1,Ki2:integer;
Begin
  For i:=0 to 600 do
     Begin
       XMin[i]:=1000;
       XMax[i]:=-1000;
     End;
  YMin:=min(y1,y2,y3);
  YMax:=max(y1,y2,y3);
  If YMin<0 then YMin:=0;
  If YMax>500 then Ymax:=500;
  Scan(x1,y1,x2,y2);
  Scan(x1,y1,x3,y3);
  Scan(x2,y2,x3,y3);
  Normal(ar1,br1,cr1,dr1,x1,y1,i11,x2,y2,i21,x3,y3,i31);
  Normal(ar2,br2,cr2,dr2,x1,y1,i12,x2,y2,i22,x3,y3,i32);
  For i:=ymin to ymax do
    For k:=xmin[i] to xmax[i] do
      begin
        Ki1:=(round(-(Ar1*k+Br1*i+Dr1)/Cr1));
        If Ki1<1 then Ki1:=1;
        If Ki1>200 then Ki1:=200;
        Ki2:=(round(-(Ar2*k+Br2*i+Dr2)/Cr2));
        If Ki2<1 then Ki2:=1;
        If Ki2>200 then Ki2:=200;
        PutPixel(k,i,DPC[Ki1,Ki2]);
      end;
End;

Procedure Int_Di4Ug(x1,y1,i11,i12,x2,y2,i21,i22,x3,y3,i31,i32,x4,y4,i41,i42:Integer);
Begin
  If SetkaIn3D then Int_DiTreug(x2,y2,i21,i22,x3,y3,i31,i32,x4,y4,i41,i42);
  IF Setka then
    Begin
      SetColor(242);
      Line(x4,y4,x2,y2);
      Line(x3,y3,x4,y4);
    End;
  If SetkaIn3D then Int_DiTreug(x1,y1,i11,i12,x2,y2,i21,i22,x3,y3,i31,i32);
  IF Setka then
    Begin
      SetColor(WC);
      Line(x1,y1,x2,y2);
      Line(x3,y3,x1,y1);
    End;
End;


end.