Unit My_Mod;
Interface
Uses My_Graph,Int_Tpu,graph,crt,DOS,my_mouse,Kub_Tpu,Types;
Const strty=240;  strtx=320;
      PoleX1=165; PoleX2=640;
      PoleY1=0;   PoleY2=480;
      MaxX=640;   MaxY=480;
      StrT=4;
      KolBut=12;  KolOptBut=7;
      ButSize=40; SpSize=8;
      PX=20;      PY=20;
      SK3D=28;    SKM=20;
      am=300;     bm=55;
      sam=200;    sbm=5;
      DefaultNSF='land_3d.slh';
      Kc=120;     KCL=10;
      TBut:array[1..KolBut] of String[30]=('Land 3D',' 3D','','࠭','㧨',
                         'ன','','','','⠢',' ணࠬ','');
      TOptBut:array[1..KolOptBut] of String[30]=('','','3D','⪠','ᢥ⪠','ਭ','⮢');
      Kol_Files=21;
      Fls_Nm:array[1..Kol_Files]of string[30]=('svga.bgi','ts25.chr','.\DATA\about.dat','saves.lst',
        '.\DATA\help.dat','.\DATA\load_bad.dat','.\DATA\load_ok.dat','.\DATA\save_ok.dat','.\PICTS\bb.pic',
        '.\PICTS\logo.pic','.\PICTS\rb.pic','.\PICTS\pls.pic','.\PICTS\mns.pic','.\DATA\lab_nofl.dat',
        '.\DATA\lab_size.dat','.\DATA\lab_simb.dat','.\DATA\lab_ok.dat','.\DATA\save_vpr.dat','.\DATA\end.dat',
        '.\PICTS\mm1.pic','.\PICTS\mm2.pic');
Type Heights=Array[0..(PX+1),0..(PY+1)] of ShortInt;
     Fast_Tab=record
        Name:string[20];
        xt,yt:integer;
        Go_File:string[12];
      end;

Var S:Integer;
    PY_2,PX_2,Err,OMR,MMR:Byte;
    SS_,fnt:Byte;
    AA,BB:Real;
    H:Heights;
    P,mm1,mm2,sp,logob,rbut,bbut,plsbut,mnsbut:Pointer;
    M:Tmouse;

Procedure Destroy;
Procedure InitGM(Gmm:Integer);
Procedure LoadImag;
Function Init_Prog:Byte;
Function IntToStr(i:Integer):String;
Procedure Mshow(x,y:Integer);
Procedure Mhide(x,y:Integer);
Procedure SetRGB;
Procedure DrawPlant(xxx,yyy:Integer);
Procedure Draw3DPlant(x_,y_:Integer;ala,alb:real);
Procedure Lansaft3D;
Procedure Grafa_Visot(x_,y_,min,max,bc,ec:Integer);
Procedure Up_OR_Down(xm,ym,tf:integer);
Procedure Edit_Map;
Function Main_Menu:Byte;
Procedure Intro;
Procedure GetRGB;
Procedure SetAngle;
Procedure About(FileName:String);
Procedure Demo_;
Procedure Save_l;
Procedure Load_l;
Function Option_Menu:Byte;
Procedure Edit_Setka;
Procedure Cmpl_Lab;
Procedure Draw_PCX(FN:String;x1x,y1y:Integer);

Implementation

Procedure Destroy;
Const mas:array[1..6] of byte=(15,11,7,9,10,13);
Var mm,nm:Integer;
    Cha:Char;
Begin
  For mm:=1 to 62 do
    Begin
      Delay(50);
      SetRGBPal(15,62-mm,62-mm,62-mm);
      SetRGBPal(9,0,0,62-mm);
      SetRGBPal(10,0,62-mm,0);
      SetRGBPal(13,31-Trunc(mm/2),0,31-Trunc(mm/2));
      SetRGBPal(11,0,31-Trunc(mm/2),31-Trunc(mm/2));
      SetRGBPal(7,16-Trunc(mm/4),16-Trunc(mm/4),16-Trunc(mm/4));
      If keypressed then
        Begin
          Repeat Cha:=ReadKey;
          Until Not Keypressed;
          Exit;
        End;
    End;
End;

Procedure InitGM(Gmm:Integer);
Var Gd:Integer;
Begin
  Gd:=InstallUserDriver('svga',nil);
  InitGraph(Gd,Gmm,'');
End;

Procedure LoadImag;
Var f:File;
Begin
  Assign(f,Fls_Nm[20]);Reset(f,1);
  GetMem(mm1,FileSize(f));
  BlockRead(f,mm1^,FileSize(f));Close(f);
  Assign(f,Fls_Nm[21]);Reset(f,1);
  GetMem(mm2,FileSize(f));
  BlockRead(f,mm2^,FileSize(f));Close(f);
  Assign(f,Fls_Nm[11]);Reset(f,1);
  GetMem(rbut,FileSize(f));
  BlockRead(f,rbut^,FileSize(f));Close(f);
  Assign(f,Fls_Nm[9]);Reset(f,1);
  GetMem(bbut,FileSize(f));
  BlockRead(f,bbut^,FileSize(f));Close(f);
  Assign(f,Fls_Nm[10]);Reset(f,1);
  GetMem(logob,FileSize(f));
  BlockRead(f,logob^,FileSize(f));Close(f);
  Assign(f,Fls_Nm[12]);Reset(f,1);
  GetMem(plsbut,FileSize(f));
  BlockRead(f,plsbut^,FileSize(f));Close(f);
  Assign(f,Fls_Nm[13]);Reset(f,1);
  GetMem(mnsbut,FileSize(f));
  BlockRead(f,mnsbut^,FileSize(f));Close(f);
End;

Function Init_Prog:Byte;
Var i,n:Integer;
    F:File;
Begin
  Init_Prog:=0;
  Smoot:=5;
  NumPic:=1;
  PictLand:=False;
  Setka:=True;
  SetkaIn3D:=True;
  PMMode:=True;
  Podsv:=True;
  Change:=False;
  PX_2:=Trunc(PX/2);
  PY_2:=Trunc(PY/2);
  bb:=Pi/3;
  aa:=Pi/6;
  For i:=1 to Kol_Files do
    Begin
      {$I-}
      Assign(f,Fls_Nm[i]);
      Reset(f);
      close(f);
      If IOResult<>0 then
        Begin
          Init_Prog:=i;
          Exit;
        End;
      {$I+}
    End;
  For i:=1 to PX do
    For n:=1 to PY do h[i,n]:=0;
End;

Function IntToStr(i:Integer):String;
Var St:String;
Begin
  Str(i,st);
  IntToStr:=st;
End;

Procedure Mshow(x,y:Integer);
Var Oc:Byte;
Begin
  Oc:=GetColor;
  SetColor(250);
  s:=ImageSize(x-2,y-2,x+12,y+12);
  GetMem(P,s);
  GetImage(x-2,y-2,x+12,y+12,P^);
  SetLineStyle(0,0,3);
  Line(x,y,x+10,y+10);
  Line(x,y,x+4,y+2);
  Line(x,y,x+2,y+4);
  SetLineStyle(0,0,1);
  SetColor(Oc);
End;

Procedure Mhide(x,y:Integer);
Begin
  PutImage(x-2,y-2,P^,0);
  FreeMem(p,s);
End;

Procedure SetRGB;
Var ii:Integer;
Begin
  SetRGBPalette(GRC,120,120,120);
  SetRGBPalette(LBC,00,250,250);
  SetRGBPalette(WC,250,250,250);
  SetRGBPalette(RC,250,0,0);
  SetRGBPalette(GC,0,250,0);
  SetRGBPalette(BC,0,0,250);
  SetRGBPalette(MC,250,0,170);
  SetRGBPalette(YC,250,250,0);
  For ii:=1 to 60 do
    Begin
      SetRGBPalette(ii,0,0,(120-ii)*2);
      SetRGBPalette(ii+60,0,ii*2,2*(60-ii));
      SetRGBPalette(ii+120,ii*2,(60-ii)*2,0);
      SetRGBPalette(ii+180,(60+ii)*2,0,0);
    End;
End;

Procedure DrawPlant(xxx,yyy:Integer);
Var p:array[1..4] of PointType;
Begin
  p[1].x:=10*xxx+am;
  p[1].y:=10*yyy+bm;
  p[2].x:=10*(xxx+1)+am;
  p[2].y:=10*yyy+bm;
  p[4].x:=10*xxx+am;
  p[4].y:=10*(yyy+1)+bm;
  p[3].x:=10*(xxx+1)+am;
  p[3].y:=10*(yyy+1)+bm;
  IF Setka Then SetColor(GRC)
    else setColor(h[xxx,yyy]*KCL+kc);
  SetLineStyle(0,0,1);
  SetFillStyle(1,h[xxx,yyy]*KCL+kc);
  FillPoly(4,p);
End;

Procedure Draw3DPlant(x_,y_:Integer;ala,alb:real);
Var x,y:array[1..4] of Integer;
Begin
  x[1]:=Trunc(cos(Alb)*((x_-PX_2)*SK3D)+sin(Alb)*((y_-PY_2)*SK3D));
  y[1]:=Trunc(sin(Ala)*sin(Alb)*((x_-PX_2)*SK3D)+cos(Ala)*h[x_,y_]*SK3D-sin(Ala)*cos(Alb)*((y_-PY_2)*SK3D));
  x[2]:=Trunc(cos(Alb)*(((x_-PX_2)+1)*SK3D)+sin(Alb)*(((y_-PY_2))*SK3D));
  y[2]:=Trunc(sin(Ala)*sin(Alb)*(((x_-PX_2)+1)*SK3D)+cos(Ala)*h[x_+1,y_]*SK3D-sin(Ala)*cos(Alb)*((y_-PY_2)*SK3D));
  x[3]:=Trunc(cos(Alb)*((x_-PX_2)*SK3D)+sin(Alb)*(((y_-PY_2)+1)*SK3D));
  y[3]:=Trunc(sin(Ala)*sin(Alb)*((x_-PX_2)*SK3D)+cos(Ala)*h[x_,y_+1]*SK3D-sin(Ala)*cos(Alb)*(((y_-PY_2)+1)*SK3D));
  x[4]:=Trunc(cos(Alb)*(((x_-PX_2)+1)*SK3D)+sin(Alb)*(((y_-PY_2)+1)*SK3D));
  y[4]:=Trunc(sin(Ala)*sin(Alb)*(((x_-PX_2)+1)*SK3D)+cos(Ala)*h[x_+1,y_+1]*SK3D-sin(Ala)*cos(Alb)*(((y_-PY_2)+1)*SK3D));
  x[1]:=StrtX+x[1];y[1]:=StrtY-y[1];
  x[2]:=StrtX+x[2];y[2]:=StrtY-y[2];
  x[3]:=StrtX+x[3];y[3]:=StrtY-y[3];
  x[4]:=StrtX+x[4];y[4]:=StrtY-y[4];
  If PictLand then
    Int_Di4Ug(x[1],y[1],10*x_,10*y_,x[2],y[2],10*(x_+1),10*y_,
            x[3],y[3],10*x_,10*(y_+1),x[4],y[4],10*(x_+1),10*(y_+1))
   Else
    Int_4Ug(x[1],y[1],h[x_,y_]*kcl+kc,x[2],y[2],h[x_+1,y_]*kcl+kc,
	    x[3],y[3],h[x_,y_+1]*kcl+kc,x[4],y[4],h[x_+1,y_+1]*kcl+kc);
End;

Procedure Lansaft3D;
Var xpl,ypl:Integer;
    sz:Longint;
    proc:Byte;
    f:File;
    Chh:Char;
    St:String;
Begin
  repeat
    ClearDevice;
    If PictLand then
      begin
        SetActivePage(1);
        ClearDevice;
        SetVisualPage(1);
        SetActivePage(0);
        Draw_PCX('00'+IntToStr(NumPic)+'.pcx',1,1);
        SetVisualPage(1);
        For Err:=1 to 200 do
          For OMR:=1 to 200 do DPC[err,omr]:=GetPixel(err,omr);
        ClearDevice;
        SetVisualPage(0);
      End;
    settextstyle(fnt,0,1);
    If (bb<3*Pi/4) and (bb>Pi/4) then
      For xpl:=(PX-1) downto 0 do
        For ypl:=0 to (PY-1) do
          Begin
            Draw3DPlant(xpl,ypl,aa,bb);
            SetColor(0);
            OutTextxy(600,5,IntToStr(Proc)+'%');
            Proc:=Trunc((((px-xpl)*py+ypl)/(px*py))*100);
            SetColor(WC);
            OutTextxy(600,5,IntToStr(Proc)+'%');
          End;
    If (bb<=5*Pi/4) and (bb>=3*Pi/4) then
      For ypl:=(PY-1) downto 0 do
        For xpl:=0 to (PX-1) do
          Begin
            Draw3DPlant(xpl,ypl,aa,bb);
            SetColor(0);
            OutTextxy(600,5,IntToStr(Proc)+'%');
            Proc:=Trunc((((py-ypl)*px+xpl)/(px*py))*100);
            SetColor(WC);
            OutTextxy(600,5,IntToStr(Proc)+'%');
          End;
    If (bb>5*Pi/4) and (bb<7*Pi/4) then
      For xpl:=0 to (PX-1) do
        For ypl:=0 to (PY-1) do
          Begin
            Draw3DPlant(xpl,ypl,aa,bb);
            SetColor(0);
            OutTextxy(600,5,IntToStr(Proc)+'%');
            Proc:=Trunc((((xpl-1)*py+ypl)/(px*py))*100);
            SetColor(WC);
            OutTextxy(600,5,IntToStr(Proc)+'%');
          End;
    If (bb>=7*Pi/4) or (bb<=Pi/4) then
      For ypl:=0 to (PY-1) do
        For xpl:=0 to (PX-1) do
          Begin
            Draw3DPlant(xpl,ypl,aa,bb);
            SetColor(0);
            OutTextxy(600,5,IntToStr(Proc)+'%');
            Proc:=Trunc((((ypl-1)*px+xpl)/(px*py))*100);
            SetColor(WC);
            OutTextxy(600,5,IntToStr(Proc)+'%');
          End;
    SetColor(0);
    OutTextxy(600,5,IntToStr(Proc)+'%');
    SetColor(WC);
    St:='Esc -   !';
    OutTextXY(Trunc((640-TextWidth(St))/2),455,St);
    Repeat
      Chh:=ReadKey;
      If Chh=#13 then
        begin
          St:=st;
          st:=st+'';
        end;
      If Chh=#0 then
        Begin
          Chh:=ReadKey;
          If (Chh=#75) then bb:=bb+(Pi/12);
          If (Chh=#77) then bb:=bb-(Pi/12);
          If bb<0 then bb:=2*Pi+bb;
          If bb>2*Pi then bb:=bb-2*Pi;
          If (Chh=#72) then aa:=aa+(Pi/12);
          If (Chh=#80) then aa:=aa-(Pi/12);
          Chh:=#0;
        End;
      If (Chh='i') or (Chh='I') then SetkaIn3D:=Not(SetkaIn3D);
      If (Chh='s') or (Chh='S') then Setka:=Not(Setka);
    Until (Chh=#27) or (Chh=#0) or (Chh='i') or (Chh='I') or (Chh='s') or (Chh='S');
  Until Chh=#27;
  If PictLand then SetRGB;
  Cleardevice;
End;

Procedure Grafa_Visot(x_,y_,min,max,bc,ec:Integer);
Var i:Integer;
    St:String;
Begin
  SetLineStyle(0,0,1);
  For i:=1 to (ec-bc) do
    Begin
      SetColor(i);
      Line(x_+i,y_,x_+i,y_+15);
    End;
  settextstyle(0,0,1);
  SetLineStyle(0,0,3);
  SetColor(WC);
  Line(x_+2,y_+15,x_+2,y_+20);
  Str(min,st);
  OutTextXY(x_-Trunc(TextWidth(st)/2),y_+22,st);
  Line(x_+Trunc((ec-bc)/2),y_+15,x_+Trunc((ec-bc)/2),y_+20);
  Str(Trunc((max+min)/2),st);
  OutTextXY(x_+Trunc((ec-bc)/2)-Trunc(TextWidth(st)/2),y_+22,st);
  Line(x_+(ec-bc),y_+15,x_+(ec-bc),y_+20);
  Str(max,st);
  OutTextXY(x_+(ec-bc)-2-Trunc(TextWidth(st)/2),y_+22,st);
  SetLineStyle(0,0,1);
End;

Procedure Up_OR_Down(xm,ym,tf:integer);
Var Fr,nn,ii:Integer;
    ohx,ohxx,ohy,ohyy:ShortInt;
Begin
  Delay(100);
  IF ((h[xm,ym]+tf)>=11) or ((h[xm,ym]+tf)<=-11) then exit;
  For ii:=(xm-1) to (xm+1) do
    For nn:=ym-1 to ym+1 do h[ii,nn]:=h[ii,nn]+tf;
  nn:=1;
  Ohx:=h[xm,ym];
  Ohxx:=h[xm,ym];
  Ohy:=h[xm,ym];
  Ohyy:=h[xm,ym];
  Fr:=50;
  If xm<=(fr) then fr:=xm-1;
  If ym<=(fr) then fr:=ym-1;
  If xm+fr>=PX then fr:=(PX-1)-xm;
  If ym+fr>=PY then fr:=(PY-1)-ym;
  Delay(51-fr);
  If Fr<1 then Exit;
  Repeat
    nn:=nn+1;
    For ii:=(xm-nn) to (xm+nn) do
      Begin
        if (tf*h[ii,ym+nn])<tf*(ohyy-tf) then h[ii,ym+nn]:=h[ii,ym+nn]+tf;
        if (tf*h[ii,ym-nn])<tf*(ohy-tf) then h[ii,ym-nn]:=h[ii,ym-nn]+tf;
      End;
    For ii:=(ym-nn+1) to (ym+nn-1) do
      Begin
        If tf*h[xm+nn,ii]<tf*(ohxx-tf) then h[xm+nn,ii]:=h[xm+nn,ii]+tf;
        If tf*h[xm-nn,ii]<tf*(ohx-tf) then h[xm-nn,ii]:=h[xm-nn,ii]+tf;
      End;
    Ohx:=h[xm-nn,ym];
    Ohxx:=h[xm+nn,ym];
    Ohy:=h[xm,ym-nn];
    Ohyy:=h[xm,ym+nn];
  Until (nn>=fr) or ((tf*h[xm+nn+1,ym]>=tf*(ohxx-tf)) and (tf*h[xm-nn-1,ym]>=tf*(ohx-tf)) and
                    (tf*h[xm,ym+nn+1]>=tf*(ohyy-tf)) and (tf*h[xm,ym-nn-1]>=tf*(ohy-tf)));
  For ii:=(xm-fr) TO (xm+fr) do
    For nn:=(ym-fr) to (ym+fr) do DrawPlant(ii,nn);
End;

Procedure Edit_Map;
Var But,XX,YY,X,Y,I,N:Integer;
    Ch:Char;
    St:String;
Begin
  SetFillStyle(1,0);
  Bar(PoleX1,PoleY1,PoleX2,PoleY2);
  settextstyle(fnt,0,1);
  SetColor(WC);
  St:='Esc -   !';
  OutTextXY(PoleX1+Trunc((640-PoleX1-TextWidth(St))/2),460,St);
  For i:=1 to (PX-1) do
    For n:=1 to (PY-1) do DrawPlant(i,n);
  Grafa_Visot(280,400,-100,100,1,2*kc);
  If PMMode then PutImage(602,1,mm1^,0)
    Else PutImage(602,1,mm2^,0);
  m.XYBut(xx,yy,but);
  MShow(xx,yy);
  Repeat
    Ch:=#0;
    If KeyPressed Then Ch:=ReadKey;
    m.XYBut(x,y,But);
    If (x<165) or (x>(MaxX-15)) or (y<2) or (y>MaxY) then
      Begin
        If x<165 then x:=165;
        If x>(MaxX-15) then x:=MaxX-15;
        If y<2 then y:=2;
        If y>MaxY then y:=MaxY;
        M.SetPos(x,y);
      End;
    If (x<>xx) or (y<>yy) then
      Begin
        MHide(xx,yy);
        MShow(x,y);
        xx:=x;
        yy:=y;
      End;
     If (But=1) and (x>603) and (y<38) then
       Begin
         Err:=1;
         MHide(x,y);
         Exit;
       End;
     If (But=1) and (x-am<=10*(PX-1)) and (y-bm<=10*(PY-1)) and (x-am>10) and (y-bm>10) then
      Begin
        Change:=True;
        MHide(x,y);
        Up_OR_Down(Trunc((x-am)/10),Trunc((y-bm)/10),1);
        MShow(x,y);
      End;
    If (But=2) and (x-am<=10*(PX-1)) and (y-bm<=10*(PY-1)) and (x-am>10) and (y-bm>10) then
      Begin
        Change:=True;
        MHide(x,y);
        Up_OR_Down(Trunc((x-am)/10),Trunc((y-bm)/10),-1);
        MShow(x,y);
      End;
  Until Ch=#27;
  Err:=0;
  MHide(x,y);
End;

Function Main_Menu:Byte;
Const ColFgr=8;
      color_:array[1..8] of Byte=(243,244,245,246,247,248,249,250);
      Days:array [0..6] of String[13]=('ᥭ','쭨','୨','।'
                                      ,'⢥','⭨','㡮');
Var But,xx,yy,x,y,ik,nk:Integer;
    tiks,hh,mm,ss,ssold,hund,year,mon,dd,dow:Word;
    plus,NumButOld,NumBut:Byte;
    t_c:array[1..7] of byte;
    Ch:Char;
    SS_Coord:Array[1..ColFgr,1..5,1..2] of Integer;
    SS_Speed:Array[1..ColFgr,1..5,1..2] of ShortInt;
    SS_Color:Array[1..ColFgr] of Byte;
  Function LeadingZero(w:Word):String;
  var s:String;
  begin
    Str(w:0,s);
    if Length(s) = 1 then
    s:='0'+s;
    LeadingZero := s;
  end;

Begin
  Randomize;
  For ik:=1 to 7 do t_c[ik]:=ik;
  IF SS_<>0 then
    For ik:=1 to ColFgr do
      Begin
        For nk:=1 to 5 do
          Begin
            SS_Coord[ik,nk,1]:=Random(PoleX2-PoleX1);
            SS_Coord[ik,nk,2]:=Random(PoleY2-PoleY1);
            SS_Coord[ik,nk,1]:=SS_Coord[ik,nk,1]+PoleX1;
            SS_Coord[ik,nk,2]:=SS_Coord[ik,nk,2]+PoleY1;
            SS_Speed[ik,nk,1]:=Random(7);
            SS_Speed[ik,nk,2]:=Random(7);
            SS_Speed[ik,nk,1]:=SS_Speed[ik,nk,1]-3;
            SS_Speed[ik,nk,2]:=SS_Speed[ik,nk,2]-3;
          End;
        SS_Color[ik]:=242+ik;
      End;
  If ss_=0 then
    begin
      SetFillStyle(1,0);
      Bar(PoleX1,PoleY1,PoleX2,PoleY2);
    End;
  PutImage(1,1,LogoB^,0);
  For ik:=2 to KolBut do PutImage(1,ButSize*(ik-1),rbut^,0);
  SetTextStyle(fnt,0,2);
  Setcolor(GC);
  For ik:=2 to KolBut do OutTextXY(Trunc((160-TextWidth(TBut[ik]))/2),
                              ButSize*(ik-1)+StrT,TBut[ik]);
  m.XYBut(xx,yy,But);
  If XX<3 then xx:=3;
  If YY<ButSize-4 then yy:=ButSize-4;
  MShow(xx,yy);
  NumButOld:=0;
  NumBut:=0;
  GetTime(hh,mm,ssold,hund);
  GetDate(year,mon,dd,dow);
  tiks:=0;
  Repeat
    If SS_<>0 then
      Begin
        Kub(200,15,0.06,0);
        Set_Angl(-0.06,0);
        Kub(625,15,0.06,0);
      End;
    plus:=0;
    SetTextStyle(0,0,3);
    If Tiks=0 then
      Begin
        For ik:=1 to 7 do
          Begin
            T_c[ik]:=T_c[ik]+1;
            If T_c[ik]>8 then T_c[ik]:=1;
            SetColor(Color_[T_c[ik]]);
            OutTextXY(1+plus,5,TBut[1,ik]);
            plus:=plus+TextWidth(TBut[1,ik])
          End;
      End
     Else If ss_=0 then
      Begin
        SetColor(YC);
        OutTextXY(1,5,TBut[1]);
      End;
    If ss_<>0 then Tiks:=Tiks+1
      else Tiks:=1;
    If (Tiks=10) and (ss_<>0) then tiks:=0;
    SetTextStyle(fnt,0,2);
    If SS_<>0 then
      Begin
        SetColor(0);
        settextstyle(fnt,0,1);
        If ss<>ssold then
          Begin
            OutTextXY(260,5,LeadingZero(hh)+':'+LeadingZero(mm)+':'+LeadingZero(ssold)+' '+days[dow]
                           +' ('+IntToStr(dd)+'.'+IntToStr(mon)+'.'+IntToStr(year)+')');
            ssold:=ss;
          End;
        For ik:=1 to ColFgr do
          Begin
            If SS_=1 then
              begin
                SetColor(0);
                Line(SS_Coord[ik,1,1],SS_Coord[ik,1,2],SS_Coord[ik,2,1],SS_Coord[ik,2,2]);
                Line(SS_Coord[ik,2,1],SS_Coord[ik,2,2],SS_Coord[ik,3,1],SS_Coord[ik,3,2]);
                Line(SS_Coord[ik,3,1],SS_Coord[ik,3,2],SS_Coord[ik,4,1],SS_Coord[ik,4,2]);
                Line(SS_Coord[ik,4,1],SS_Coord[ik,4,2],SS_Coord[ik,5,1],SS_Coord[ik,5,2]);
                Line(SS_Coord[ik,5,1],SS_Coord[ik,5,2],SS_Coord[ik,1,1],SS_Coord[ik,1,2]);
              End;
            For nk:=1 to 5 do
              Begin
                SS_Coord[ik,nk,1]:=SS_Coord[ik,nk,1]+SS_Speed[ik,nk,1];
                SS_Coord[ik,nk,2]:=SS_Coord[ik,nk,2]+SS_Speed[ik,nk,2];
                If SS_Coord[ik,nk,1]<PoleX1 Then
                  Begin
                    SS_Speed[ik,nk,1]:=-SS_Speed[ik,nk,1];
                    SS_Coord[ik,nk,1]:=SS_Coord[ik,nk,1]+SS_Speed[ik,nk,1];
                  End;
                If SS_Coord[ik,nk,1]>PoleX2 Then
                  Begin
                    SS_Speed[ik,nk,1]:=-SS_Speed[ik,nk,1];
                    SS_Coord[ik,nk,1]:=SS_Coord[ik,nk,1]+SS_Speed[ik,nk,1];
                  End;
                If SS_Coord[ik,nk,2]<PoleY1 Then
                  Begin
                    SS_Speed[ik,nk,2]:=-SS_Speed[ik,nk,2];
                    SS_Coord[ik,nk,2]:=SS_Coord[ik,nk,2]+SS_Speed[ik,nk,2];
                  End;
                If SS_Coord[ik,nk,2]>PoleY2 Then
                  Begin
                    SS_Speed[ik,nk,2]:=-SS_Speed[ik,nk,2];
                    SS_Coord[ik,nk,2]:=SS_Coord[ik,nk,2]+SS_Speed[ik,nk,2];
                  End;
              End;
            SetColor(SS_Color[ik]);
            Line(SS_Coord[ik,1,1],SS_Coord[ik,1,2],SS_Coord[ik,2,1],SS_Coord[ik,2,2]);
            Line(SS_Coord[ik,2,1],SS_Coord[ik,2,2],SS_Coord[ik,3,1],SS_Coord[ik,3,2]);
            Line(SS_Coord[ik,3,1],SS_Coord[ik,3,2],SS_Coord[ik,4,1],SS_Coord[ik,4,2]);
            Line(SS_Coord[ik,4,1],SS_Coord[ik,4,2],SS_Coord[ik,5,1],SS_Coord[ik,5,2]);
            Line(SS_Coord[ik,5,1],SS_Coord[ik,5,2],SS_Coord[ik,1,1],SS_Coord[ik,1,2]);
          End;
        settextstyle(fnt,0,1);
        SetColor(WC);
        GetTime(hh,mm,ss,hund);
        GetDate(year,mon,dd,dow);
        OutTextXY(260,5,LeadingZero(hh)+':'+LeadingZero(mm)+':'+LeadingZero(ssold)+' '+days[dow]
                          +' ('+IntToStr(dd)+'.'+IntToStr(mon)+'.'+IntToStr(year)+')');
        settextstyle(fnt,0,2);
      End;
    m.XYBut(x,y,But);
    If (x<2) or (x>162) or (y<ButSize-4) or (y>MaxY) then
      Begin
        If x<2 then x:=2;
        If x>162 then x:=162;
        If y<ButSize-4 then y:=ButSize-4;
        If y>MaxY then y:=MaxY;
        M.SetPos(x,y);
      End;
    If (x<>xx) or (y<>yy) then
      Begin
        MHide(xx,yy);
        MShow(x,y);
        xx:=x;
        yy:=y;
      End;
    NumButOld:=NumBut;
    NumBut:=0;
    For ik:=2 to KolBut do
      If (Y>ButSize*(ik-1)) and (y<(ButSize*ik-SpSize)) then NumBut:=Ik;
    If NumBut<>NumButOld then
      Begin
        SetColor(WC);
        If NumBut<>0 then
          Begin
            MHide(xx,yy);
            PutImage(1,ButSize*(NumBut-1),bbut^,0);
            OutTextXY(Trunc((160-TextWidth(TBut[NumBut]))/2),ButSize*(NumBut-1)+StrT,TBut[NumBut]);
            MShow(xx,yy);
          End;
        SetColor(GC);
        If NumButOld<>0 then
          Begin
            MHide(xx,yy);
            PutImage(1,ButSize*(NumButOld-1),rbut^,0);
            OutTextXY(Trunc((160-TextWidth(TBut[NumButOld]))/2),ButSize*(NumButOld-1)+StrT,TBut[NumButOld]);
            MShow(xx,yy);
          End;
      End;
    If KeyPressed then
      Begin
        ch:=ReadKey;
        If Ch=#0 then
          Begin
            Ch:=ReadKey;
            If (Ch=#16) or (Ch=#68) then
              Begin
                Main_Menu:=KolBut;
                Exit;
              End;
            If (Ch=#59) or (Ch=#35) then
              Begin
                Main_Menu:=1;
                Exit;
              End;
          End;
        If Ch=#13 then
              Begin
                Main_Menu:=2;
                Exit;
              End;
      End;
  Until (But=1) And (NumBut<>0);
  MHide(x,y);
  SetTextStyle(0,0,3);
  SetColor(YC);
  OutTextXY(1,5,TBut[1]);
  Main_Menu:=NumBut;
End;

Procedure Intro;
var cc,lin,bb,yy,xx,ii:integer;
    xxx:array[1..200] of integer;
    vvv,yyy:array[1..200] of real;
    st,print:string;
    Chh:Char;
begin
  cleardevice;
  lin:=0;
  repeat
  lin:=lin+1;
  case lin of
    1:begin settextstyle(fnt,0,6);cc:=13;yy:=80;xx:=30;print:='ॢ਩';end;
    2:begin settextstyle(fnt,0,5);cc:=10;yy:=205;xx:=78;print:='PRESENTSPROGRAM:';end;
    3:begin settextstyle(fnt,0,7);cc:=9;yy:=330;xx:=150;print:='Land"3D"';end;
   end;
  st:='';
  for ii:=1 to length(print) do
    begin
      bb:=630;
      repeat
        bb:=bb-1;
        setcolor(15);
        outtextxy(bb,yy,print[ii]);
        if keypressed then
          Begin
            repeat
              chh:=ReadKey;
            Until not keypressed;
            Destroy;
            exit;
          End;
        delay(1);
        setcolor(0);
        outtextxy(bb,yy,print[ii]);
      until bb=(xx+TextWidth(St));
      st:=st+print[ii];
      if (st='ॢ') or (st='Land') or (st='PRESENTS') then st:=st+'  ';
      setcolor(cc);
      outtextxy(xx,yy,st);
      delay(30);
    end;
  until lin=3;
  delay(1500);
  SetColor(7);
  settextstyle(0,1,2);
  Print:='DegMan Incorporation <1998>';
  St:='';
  For ii:=Length(Print) downto 1 do
    Begin
      St:=Print[ii]+st;
      outtextxy(630,20,St);
      delay(200);
    End;
  delay(2000);
  for ii:=1 to 200 do
    begin
      vvv[ii]:=random;
      if vvv[ii]<0.05 then vvv[ii]:=0.05;
      yyy[ii]:=random(140);
      yyy[ii]:=yyy[ii]-70;
      xxx[ii]:=random(640);
    end;
  repeat
    for ii:=1 to 200 do
      begin
        putpixel(xxx[ii],trunc(yyy[ii]),15);
        if (getpixel(xxx[ii],trunc(yyy[ii])+1)<>0) and (getpixel(xxx[ii],trunc(yyy[ii])+1)<>15) then
          begin
            putpixel(xxx[ii],trunc(yyy[ii]),11);
            xxx[ii]:=random(640);
            yyy[ii]:=0;
          end;
      end;
    if keypressed then
      Begin
        repeat
          chh:=ReadKey;
        Until not keypressed;
        Destroy;
        exit;
      End;
    for ii:=1 to 200 do
      begin
        putpixel(xxx[ii],trunc(yyy[ii]),0);
        yyy[ii]:=yyy[ii]+vvv[ii];
        If yyy[ii]>480 then
          Begin
            yyy[ii]:=0;
            xxx[ii]:=random(640);
          End;
     end;
  until keypressed;
  Chh:=ReadKey;
  Destroy;
  cleardevice;
End;

Procedure GetRGB;
Var inn,nn,x_x:Integer;
    Ch:Char;
    St:String;
Begin
  SetFillStyle(1,0);
  Bar(PoleX1,PoleY1,PoleX2,PoleY2);
  For inn:=1 to 240 do
    Begin
      SetColor(inn);
      x_x:=PoleX1+2*inn;
      Line(x_x,PoleY1+20,x_x,PoleY2-30);
      Line(x_x-1,PoleY1+20,x_x-1,PoleY2-30);
    End;
  settextstyle(fnt,0,1);
  SetColor(WC);
  St:='Esc -   !';
  OutTextXY(PoleX1+Trunc((640-PoleX1-TextWidth(St))/2),455,St);
  Repeat
    Ch:=ReadKey;
  Until Ch=#27;
End;

Procedure SetAngle;
Var x,y,xx,yy,But:Integer;
    Ch:Char;
    St:String;
Begin
  SetFillStyle(1,0);
  Bar(PoleX1+170,PoleY1,PoleX2,PoleY2);
  settextstyle(fnt,0,1);
  SetColor(WC);
  St:='Esc -  !';
  OutTextXY(PoleX1+170+Trunc((470-PoleX1-TextWidth(St))/2),455,St);
  settextstyle(fnt,0,2);
  SetColor(MC);
  St:='  ⨪:';
  OutTextXY(PoleX1+170+Trunc((470-PoleX1-TextWidth(St))/2),340,St);
  PutImage(410,365,plsbut^,0);
  PutImage(530,365,mnsbut^,0);
  SetColor(MC);
  settextstyle(0,0,3);
  OutTextXY(457,370,IntToStr(Trunc((180/Pi)*aa))+'');
  settextstyle(fnt,0,2);
  SetColor(MC);
  St:='  ਧ⠫:';
  OutTextXY(PoleX1+170+Trunc((470-PoleX1-TextWidth(St))/2),210,St);
  PutImage(410,235,plsbut^,0);
  PutImage(530,235,mnsbut^,0);
  SetColor(MC);
  settextstyle(0,0,3);
  OutTextXY(457,240,IntToStr(Trunc((180/Pi)*bb))+'');
  m.XYBut(xx,yy,But);
  MShow(xx,yy);
  Repeat
    If KeyPressed then Ch:=ReadKey;
    m.XYBut(x,y,But);
    If (x<PoleX1+170) or (x>(MaxX-15)) or (y<2) or (y>MaxY) then
      Begin
        If x>(MaxX-15) then x:=MaxX-15;
        If x<PoleX1+170 then x:=PoleX1+170;
        If y<2 then y:=2;
        If y>MaxY then y:=MaxY;
        M.SetPos(x,y);
      End;
    If (x<>xx) or (y<>yy) then
      Begin
        MHide(xx,yy);
        MShow(x,y);
        xx:=x;
        yy:=y;
      End;
    If (But=1) And (y>365) and (y<400) and (((x>410) and (x<445)) or ((x>530) and (x<565))) then
      Begin
        Delay(20);
        SetColor(0);
        settextstyle(0,0,3);
        OutTextXY(457,370,IntToStr(Trunc((180/Pi)*aa))+'');
        If (x>410) and (x<445) then aa:=aa+0.001;
        If (x>530) and (x<565) then aa:=aa-0.001;
        If aa<0 Then aa:=0;
        If aa>(Pi/2) Then aa:=(Pi/2);
        SetColor(MC);
        settextstyle(0,0,3);
        OutTextXY(457,370,IntToStr(Trunc((180/Pi)*aa))+'');
      End;
    If (But=1) And (y>235) and (y<270) and (((x>410) and (x<445)) or ((x>530) and (x<565))) then
      Begin
        Delay(20);
        SetColor(0);
        settextstyle(0,0,3);
        OutTextXY(457,240,IntToStr(Trunc((180/Pi)*bb))+'');
        If (x>410) and (x<445) then bb:=bb+0.001;
        If (x>530) and (x<565) then bb:=bb-0.001;
        If bb<0 Then bb:=0;
        If bb>(Pi/2) Then bb:=(Pi/2);
        SetColor(MC);
        settextstyle(0,0,3);
        OutTextXY(457,240,IntToStr(Trunc((180/Pi)*bb))+'');
      End;
  Until (Ch=#27);
  MHide(x,y);
End;

Procedure About(FileName:String);
Var F:Text;
    S:String;
    i,n,k:Integer;
    Ch:Char;
Begin
  Assign(f,FileName);
  Reset(f);
  SetFillStyle(1,0);
  Bar(PoleX1,PoleY1,PoleX2,PoleY2);
  ReadLn(F,S);
  Val(S,N,I);
  SetColor(GC);
  settextstyle(fnt,0,2);
  I:=0;
  Repeat
    I:=I+1;
    ReadLn(F,S);
    For K:=1 to Length(s) do s[k]:=Chr(255-Ord(S[k]));
    OutTextXY(PoleX1+Trunc((450-TextWidth(S))/2),i*20,S);
  Until I=N;
  Close(f);
  settextstyle(fnt,0,2);
  SetColor(WC);
  S:='Esc -   !';
  OutTextXY(PoleX1+Trunc((640-PoleX1-TextWidth(S))/2),440,S);
  Repeat
    Ch:=ReadKey;
  Until Ch=#27;
End;

Procedure Demo_;
Var d,f:Integer;
    s:String;
    Ch:Char;
Begin
  SetFillStyle(1,0);
  Bar(PoleX1,PoleY1,PoleX2,PoleY2);
  SetColor(YC);
  settextstyle(fnt,0,2);
  S:='';
  OutTextXY(PoleX1+Trunc((475-TextWidth(S))/2),40,S);
  SetColor(MC);
  S:='1)';
  OutTextXY(PoleX1+Trunc((475-TextWidth(S))/2),80,S);
  S:='2)ᨭ';
  OutTextXY(PoleX1+Trunc((475-TextWidth(S))/2),105,S);
  S:='3)';
  OutTextXY(PoleX1+Trunc((475-TextWidth(S))/2),130,S);
  S:='4)';
  OutTextXY(PoleX1+Trunc((475-TextWidth(S))/2),155,S);
  SetColor(BC);
  S:='   1  4:';
  OutTextXY(PoleX1+Trunc((475-TextWidth(S))/2),400,S);
  settextstyle(fnt,0,1);
  SetColor(WC);
  S:='Esc -   !';
  OutTextXY(PoleX1+Trunc((640-PoleX1-TextWidth(S))/2),455,S);
  Repeat
    Ch:=ReadKey;
    Case Ch of
      '1':Begin
            For d:=0 to PX do
              For f:=0 to PY do
                h[d,f]:=Trunc(Sin(2*Pi*(d/PX))*8);
            Lansaft3D;
            Exit;
          End;
      '2':Begin
            For d:=0 to PX do
              For f:=0 to PY do
                h[d,f]:=Trunc(Cos(2*Pi*(f/PY))*8);
            Lansaft3D;
            Exit;
          End;
      '3':Begin
            for d:=0 to PX do
              for f:=0 to PY do
                h[d,f]:=trunc(sin(f*0.15)*trunc(sin(d*0.15)*8));
            Lansaft3D;
            Exit;
          End;
      '4':Begin
            for d:=0 to PX do
              for f:=0 to PY do
                h[d,f]:=trunc(sin(f*0.15)*trunc(sin(d*0.15)*(-8)));
            Lansaft3D;
            Exit;
          End;
    End;
  Until Ch=#27;
End;

Procedure Save_l;
Var F:Text;
    F1:File of Heights;
    Size_f,x,y,n,i,k,u:Integer;
    DirInfo:SearchRec;
    S:String;
    Ch:Char;
    SaveToFile:String[12];
    File_Line:Array[1..10] of String[32];
    F_T:array[1..8] of Fast_Tab;
Begin
  SetTextStyle(0,0,1);
  Assign(F,'SAVES.LST');
  Reset(F);
  For I:=1 to 10 do File_Line[i]:='';
  For I:=1 to 8 do
    Begin
      f_t[i].name:='';
      f_t[i].xt:=0;
      f_t[i].yt:=0;
      f_t[i].go_file:='';
    End;
  I:=0;
  K:=0;
  repeat
    I:=I+1;
    N:=0;
    While not Eoln(F) do
      Begin
        Read(F,Ch);
        if (ch<>'&') and (ch<>#35) and (ch<>#10) and (ch<>#13) then N:=N+1;
        if ch=#35 then
          begin
            K:=K+1;
            f_t[k].xt:=N+1;
            f_t[k].yt:=I;
            repeat
              Read(F,ch);
              if ch<>#32 then f_t[k].name:=f_t[k].name+ch;
            until ch=#32;
            repeat
              Read(F,ch);
              if ch<>#35 then f_t[k].go_file:=f_t[k].go_file+ch;
            until ch=#35;
            for U:=1 to length(f_t[k].name) do
              begin
                N:=N+1;
                File_Line[i]:=File_Line[i]+' ';
              end;
          end;
          if (ch<>'&') and (ch<>#35) and (ch<>#10) and (ch<>#13) then File_Line[i]:=File_Line[i]+ch;
          If ch='&' then File_Line[i]:=File_Line[i]+'Save';
          If ch='&' then N:=N+4;
        end;
    Read(F,ch);
  until i=10;
  Close(f);
  x:=trunc((getmaxx-length(File_Line[1])*8)/2);
  y:=trunc((getmaxy-I*8)/2);
  Size_F:=imagesize(trunc(x),trunc(y),trunc(x)+length(File_Line[1])*8,trunc(y)+i*8);
  getmem(p,Size_F);
  getimage(trunc(x),trunc(y),trunc(x)+length(File_Line[1])*8,trunc(y)+i*8,p^);
  setfillstyle(1,0);
  bar(trunc(x),trunc(y),trunc(x)+length(File_Line[1])*8,trunc(y)+i*8);
  for u:=1 to I do
     for n:=1 to length(File_Line[u]) do
        begin
          if (ord(File_Line[u,n])>185) and (ord(File_Line[u,n])<206) then
                setcolor(WC) else setcolor(LBC);
          outtextxy(trunc(x)+(n-1)*8,trunc(y)+(u-1)*8,File_Line[u,n]);
        end;
  i:=1;
  repeat
    for u:=1 to k do
      begin
        setcolor(LBC);
        if u=i then setcolor(MC);
        outtextxy(trunc(x)+(f_t[u].xt-1)*8,trunc(y)+(f_t[u].yt-1)*8,f_t[u].name);
      end;
    repeat
      ch:=readkey;
      if (K>0) and (ch=#13) then SaveToFile:=F_t[I].Go_file;
      case ch of
        'a'..'z','A'..'Z':
          begin
            if length(f_t[i].name)<12 then f_t[i].name:=f_t[i].name+Ch;
            setcolor(MC);
            outtextxy(trunc(x)+(f_t[i].xt-1)*8,trunc(y)+(f_t[i].yt-1)*8,f_t[i].name);
          End;
        ' ':
          begin
            if length(f_t[i].name)<12 then f_t[i].name:=f_t[i].name+'_';
            setcolor(MC);
            outtextxy(trunc(x)+(f_t[i].xt-1)*8,trunc(y)+(f_t[i].yt-1)*8,f_t[i].name);
          End;
        #27:
          Begin
            putimage(trunc(x),trunc(y),p^,0);
            freemem(p,size_f);
            Exit;
          End;
      end;
    until (ch=#13) or (ch=#9) or (ch=#15) or (ch=#8);
    if ch=#8 then
      begin
        setcolor(0);
        outtextxy(trunc(x)+(f_t[i].xt-1)*8,trunc(y)+(f_t[i].yt-1)*8,f_t[i].name);
        delete(f_t[i].name,length(f_t[i].name),1);
        f_t[i].name:=f_t[i].name;
        setcolor(MC);
        outtextxy(trunc(x)+(f_t[i].xt-1)*8,trunc(y)+(f_t[i].yt-1)*8,f_t[i].name);
      end;
    if ch=#9 then i:=i+1;
    if ch=#15 then i:=i-1;
    if i<1 then i:=k;
    if i>k then i:=1;
  until ch=#13;
  For U:=2 to 9 do delete(file_line[u],2,12);
  For U:=1 to 8 do While length(f_t[u].name)<12 do f_t[u].name:=f_t[u].name+'_';
  For U:=2 to 9 do insert('#'+f_t[u-1].name+' '+f_t[u-1].go_file+'#',file_line[u],3);
  File_Line[1]:='&ͻ';
  Rewrite(f);
  For U:=1 to 10 do writeln(f,file_line[u]);
  close(f);
  putimage(trunc(x),trunc(y),p^,0);
  freemem(p,size_f);
  assign(f1,'.\SAVES\'+SaveToFile);
  rewrite(f1);
  write(f1,h);
  close(f1);
  Change:=False;
  About(Fls_Nm[8]);
End;

Procedure Load_l;
var F1:file of Heights;
    F:Text;
    Ch_S:Char;
    SaveToFile:String[12];
    File_Line:Array[1..10] of String[20];
    x,y,Size_F:integer;
    N,I,K,U:byte;
    F_T:array[1..8] of Fast_Tab;
Begin
  SetTextStyle(0,0,1);
  Assign(F,'SAVES.LST');
  reset(F);
  for I:=1 to 10 do File_Line[i]:='';
  for I:=1 to 8 do
    begin
      f_t[i].name:='';
      f_t[i].xt:=0;
      f_t[i].yt:=0;
      f_t[i].go_file:='';
    End;
  I:=0;
  k:=0;
  repeat
    I:=I+1;
    N:=0;
    While not Eoln(F) do
      Begin
        Read(F,Ch_S);
        if (ch_s<>'&') and (ch_s<>#35) and (ch_s<>#10) and (ch_s<>#13) then N:=N+1;
        if ch_s=#35 then
          begin
            K:=K+1;
            f_t[k].xt:=N+1;
            f_t[k].yt:=I;
            repeat
              Read(F,ch_s);
              if ch_s<>#32 then f_t[k].name:=f_t[k].name+ch_s;
            until ch_s=#32;
            repeat
              Read(F,ch_s);
              if ch_s<>#35 then f_t[k].go_file:=f_t[k].go_file+ch_s;
            until ch_s=#35;
            for U:=1 to length(f_t[k].name) do
              begin
                N:=N+1;
                File_Line[i]:=File_Line[i]+' ';
              end;
          end;
          if (ch_s<>'&') and (ch_s<>#35) and (ch_s<>#10) and (ch_s<>#13) then
             File_Line[i]:=File_Line[i]+ch_s;
          If ch_s='&' then File_Line[i]:=File_Line[i]+'Load';
          If ch_s='&' then N:=N+4;
        end;
    Read(F,ch_s);
  until i=10;
  Close(f);
  x:=trunc((getmaxx-length(File_Line[1])*8)/2);
  y:=trunc((getmaxy-I*8)/2);
  Size_F:=imagesize(trunc(x),trunc(y),trunc(x)+length(File_Line[1])*8,trunc(y)+i*8);
  getmem(p,Size_F);
  getimage(trunc(x),trunc(y),trunc(x)+length(File_Line[1])*8,trunc(y)+i*8,p^);
  setfillstyle(1,0);
  bar(trunc(x),trunc(y),trunc(x)+length(File_Line[1])*8,trunc(y)+i*8);
  for u:=1 to I do
     for n:=1 to length(File_Line[u]) do
        begin
          if (ord(File_Line[u,n])>185) and (ord(File_Line[u,n])<206) then
                setcolor(WC) else setcolor(LBC);
          outtextxy(trunc(x)+(n-1)*8,trunc(y)+(u-1)*8,File_Line[u,n]);
        end;
  i:=1;
  repeat
    for u:=1 to k do
      begin
        setcolor(LBC);
        if u=i then setcolor(MC);
        outtextxy(trunc(x)+(f_t[u].xt-1)*8,trunc(y)+(f_t[u].yt-1)*8,f_t[u].name);
      end;
    repeat
      ch_s:=readkey;
      if (K>0) and (ch_s=#13) then SaveToFile:=F_t[I].Go_file;
    until (ch_s=#27) or (ch_s=#13) or (ch_s=#9) or (ch_s=#15) or (ch_s=#8);
    if ch_s=#9 then i:=i+1;
    if ch_s=#15 then i:=i-1;
    If Ch_s=#27 then
      Begin
        putimage(trunc(x),trunc(y),p^,0);
        freemem(p,size_f);
        Exit;
      End;
    if i<1 then i:=k;
    if i>k then i:=1;
  until ch_s=#13;
  putimage(trunc(x),trunc(y),p^,0);
  freemem(p,size_f);
  assign(f1,'.\SAVES\'+SaveToFile);
  {$I-}
  Reset(f1);
  Close(f1);
  {$I+}
  if IoResult=0 then
    begin
      If Change then
        Begin
          About(Fls_Nm[18]);
          Save_l;
        End;
      assign(f1,'.\SAVES\'+SaveToFile);
      reset(f1);
      read(f1,h);
      close(f1);
      About(Fls_Nm[7]);
      Change:=False;
      Exit;
    end;
  About(Fls_Nm[6]);
End;

Function Option_Menu:Byte;
Var But,xx,yy,x,y,ik,nk:Integer;
    NumButOld,NumBut:Byte;
    Ch:Char;
Begin
  Randomize;
  SetFillStyle(1,0);
  Bar(PoleX1+170,PoleY1,PoleX2,PoleY2);
  For ik:=6 to (5+KolOptBut) do PutImage(PoleX1+5,ButSize*(ik-1),rbut^,0);
  SetTextStyle(fnt,0,2);
  Setcolor(GC);
  For ik:=6 to (5+KolOptBut) do
    OutTextXY(PoleX1+5+Trunc((160-TextWidth(TOptBut[ik-5]))/2),ButSize*(ik-1)+StrT,TOptBut[ik-5]);
  m.XYBut(xx,yy,But);
  If XX<PoleX1 then xx:=PoleX1;
  If YY<(ButSize*5-4) then yy:=(ButSize*5-4);
  SetTextStyle(fnt,0,1);
  SetColor(WC);
  OutTextXY(PoleX1+170,200,'  ⨪: '+IntToStr(Trunc((180/Pi)*aa))+'');
  OutTextXY(PoleX1+170,230,'  १⠫: '+IntToStr(Trunc((180/Pi)*bb))+'');
  If Setka Then OutTextXY(PoleX1+170,260,'孮⭠ ⪠: .')
    Else OutTextXY(PoleX1+170,260,'孮⭠ ⪠: .');
  If PMMode Then OutTextXY(PoleX1+170,290,' ।஢ ࠬ.')
    Else OutTextXY(PoleX1+170,290,' ।஢ ⪨.');
  If Podsv Then OutTextXY(PoleX1+170,320,'ᢨ⪠   ।.: .')
    Else OutTextXY(PoleX1+170,320,'ᢨ⪠   ।.: .');
  If SetkaIn3D Then OutTextXY(PoleX1+170,350,' 3D ०: ௮')
    Else OutTextXY(PoleX1+170,350,' 3D ०: ⮫쪮 ⪠');
  If PictLand Then OutTextXY(PoleX1+170,380,' ⥪'+IntToStr(NumPic)+': .')
    Else OutTextXY(PoleX1+170,380,' ⥪'+IntToStr(NumPic)+': .');
  OutTextXY(PoleX1+170,410,'⮢ 孮: '+IntToStr(Smoot*10)+'%');
  SetTextStyle(fnt,0,2);
  MShow(xx,yy);
  NumButOld:=0;
  NumBut:=0;
  Repeat
    m.XYBut(x,y,But);
    If (x<PoleX1) or (x>(PoleX1+165)) or (y<(ButSize*5-4)) or (y>(ButSize*(5+KolOptBut)+4)) then
      Begin
        If x<PoleX1 then x:=PoleX1;
        If x>PoleX1+165 then x:=165+PoleX1;
        If y<(ButSize*5-4) then y:=(ButSize*5-4);
        If y>(ButSize*(5+KolOptBut)+4) then y:=(ButSize*(5+KolOptBut)+4);
        M.SetPos(x,y);
      End;
    If (x<>xx) or (y<>yy) then
      Begin
        MHide(xx,yy);
        MShow(x,y);
        xx:=x;
        yy:=y;
      End;
    NumButOld:=NumBut;
    NumBut:=0;
    For ik:=6 to (5+KolOptBut) do
      If (Y>ButSize*(ik-1)) and (y<(ButSize*ik-SpSize)) then NumBut:=Ik;
    If NumBut<>NumButOld then
      Begin
        SetColor(WC);
        If NumBut<>0 then
          Begin
            MHide(xx,yy);
            PutImage(PoleX1+5,ButSize*(NumBut-1),bbut^,0);
            OutTextXY(PoleX1+5+Trunc((160-TextWidth(TOptBut[NumBut-5]))/2),ButSize*(NumBut-1)+StrT,TOptBut[NumBut-5]);
            MShow(xx,yy);
          End;
        SetColor(GC);
        If NumButOld<>0 then
          Begin
            MHide(xx,yy);
            PutImage(PoleX1+5,ButSize*(NumButOld-1),rbut^,0);
            OutTextXY(PoleX1+5+Trunc((160-TextWidth(TOptBut[NumButOld-5]))/2),ButSize*(NumButOld-1)+StrT,TOptBut[NumButOld-5]);
            MShow(xx,yy);
          End;
      End;
    If But=2 then
      Begin
        But:=1;
        NumBut:=13;
      End;
    If KeyPressed then
      Begin
        ch:=ReadKey;
        If ch=#27 then
          Begin
            But:=1;
            NumBut:=13;
          End;
        ch:=#0;
      End;
  Until (But=1) And (NumBut<>0);
  MHide(x,y);
  SetTextStyle(0,0,3);
  SetColor(YC);
  OutTextXY(1,5,TBut[1]);
  Option_Menu:=NumBut;
End;

Procedure Line_H(CCol,jl:Integer);
Var ddd:Integer;
Begin
  For ddd:=1 to (PX-1) do
    Begin
      If CCol<>0 then SetColor(YC)
        Else SetColor(0);
      If jl>1 then
        Line(200+(ddd-1)*SKM,410-2*h[ddd,jl-1],200+ddd*SKM,410-2*h[ddd+1,jl-1]);
      If CCol<>0 then SetColor(RC);
      If Jl<PY then
        Line(200+(ddd-1)*SKM,410-2*h[ddd,jl+1],200+ddd*SKM,410-2*h[ddd+1,jl+1]);
      SetColor(CCol);
      Line(200+(ddd-1)*SKM,410-2*h[ddd,jl],200+ddd*SKM,410-2*h[ddd+1,jl]);
    End;
  If Podsv then
  Begin
    if CCol<>0 then SetColor(BC)
      Else If Setka then SetColor(GRC) Else SetColor(KC);
    Line(sam,sbm+(jl-1)*SKM,sam+(PX-1)*SKM,sbm+(jl-1)*SKM);
    if CCol<>0 then SetColor(YC);
    If jl>1 then Line(sam,sbm+(jl-2)*SKM,sam+(PX-1)*SKM,sbm+(jl-2)*SKM);
    if CCol<>0 then SetColor(RC);
    If jl<PY then Line(sam,sbm+(jl)*SKM,sam+(PX-1)*SKM,sbm+(jl)*SKM);
  End;
End;

Procedure Edit_Setka;
Var Szz,But,XX,YY,X,Y,I,N,il,jl,iol,jol:Integer;
    Ch:Char;
    St:String;
Begin
  SetFillStyle(1,0);
  Bar(PoleX1,PoleY1,PoleX2,PoleY2);
  If PMMode then PutImage(602,1,mm1^,0)
    Else PutImage(602,1,mm2^,0);
  settextstyle(fnt,0,1);
  SetColor(WC);
  St:='Esc -   !';
  OutTextXY(PoleX1+Trunc((640-PoleX1-TextWidth(St))/2),460,St);
  For i:=1 to (PX-1) do
    For n:=1 to (PY-1) do
      Int_4Ug((i-1)*SKM+sam,(n-1)*SKM+sbm,h[i,n]*KCL+kc,
             i*SKM+sam,(n-1)*SKM+sbm,h[i+1,n]*KCL+kc,
             (i-1)*SKM+sam,n*SKM+sbm,h[i,n+1]*KCL+kc,
	     i*SKM+sam,n*SKM+sbm,h[i+1,n+1]*KCL+kc);
  Grafa_Visot(280,435,-100,100,1,2*kc);
  m.XYBut(xx,yy,but);
  If (xx>sam) and (xx<sam+px*SKM) and (yy>sbm) and (yy<sbm+py*SKM) then
    Begin
      iol:=0;
      jol:=0;
      i:=xx-sam;
      While (i>SKM) do
        Begin
          Inc(iol);
          i:=i-SKM;
        End;
      n:=yy-sbm;
      While (n>SKM) do
        Begin
          Inc(jol);
          n:=n-SKM;
        End;
      If n>(SKM/2) then Inc(jol);
      If i>(SKM/2) then Inc(iol);
    End
   Else
    Begin
      iol:=-1;
      jol:=-1;
    End;
  If (iol>=0) and (jol>=0) then
    Begin
      Szz:=ImageSize(sam+iol*SKM-4,sbm+jol*SKM-4,sam+iol*SKM+4,sbm+jol*SKM+4);
      GetMem(SP,Szz);
      GetImage(sam+iol*SKM-4,sbm+jol*SKM-4,sam+iol*SKM+4,sbm+jol*SKM+4,SP^);
      SetLineStyle(0,0,3);
      SetColor(0);
      Circle(sam+iol*SKM,sbm+jol*SKM,2);
      SetLineStyle(0,0,1);
      Line_h(BC,jol+1);
    End;
  MShow(xx,yy);
  Repeat
    Ch:=#0;
    If KeyPressed Then Ch:=ReadKey;
    m.XYBut(x,y,But);
    If (x<165) or (x>(MaxX-15)) or (y<2) or (y>MaxY) then
      Begin
        If x<165 then x:=165;
        If x>(MaxX-15) then x:=MaxX-15;
        If y<2 then y:=2;
        If y>MaxY then y:=MaxY;
        M.SetPos(x,y);
      End;
    If (x<>xx) or (y<>yy) then
      Begin
        MHide(xx,yy);
        MShow(x,y);
        xx:=x;
        yy:=y;
      End;
    If (x>sam) and (x<sam+(px-1)*SKM) and (y>sbm) and (y<sbm+(py-1)*SKM) then
      Begin
        il:=0;
        jl:=0;
        i:=x-sam;
        While (i>SKM) do
          Begin
            Inc(il);
            i:=i-SKM;
          End;
        n:=y-sbm;
        While (n>SKM) do
          Begin
            Inc(jl);
            n:=n-SKM;
          End;
        If n>(SKM/2) then Inc(jl);
        If i>(SKM/2) then Inc(il);
      End
     Else
      Begin
        il:=-1;
        jl:=-1;
      End;
    If (il<>iol) or (jl<>jol) then
      Begin
        MHide(x,y);
        If (iol>=0) and (jol>=0) then
          Begin
            PutImage(sam+iol*SKM-4,sbm+jol*SKM-4,SP^,0);
            FreeMem(SP,Szz);
            Line_h(0,jol+1);
          End;
        If (il>=0) and (jl>=0) then
          Begin
            Szz:=ImageSize(sam+il*SKM-4,sbm+jl*SKM-4,sam+il*SKM+4,sbm+jl*SKM+4);
            GetMem(SP,Szz);
            GetImage(sam+il*SKM-4,sbm+jl*SKM-4,sam+il*SKM+4,sbm+jl*SKM+4,SP^);
            SetLineStyle(0,0,3);
            SetColor(0);
            Circle(sam+il*SKM,sbm+jl*SKM,2);
            SetLineStyle(0,0,1);
            Line_h(BC,jl+1);
          End;
        jol:=jl;
        iol:=il;
        MShow(x,y);
      End;
    If (But=1) and (x>603) and (y<38) then
       Begin
         Err:=1;
         MHide(x,y);
         Exit;
       End;
    If (But=1) and (il>=0) and (jl>=0) then
      Begin
        Change:=True;
        MHide(x,y);
        Line_H(0,jol+1);
        PutImage(sam+iol*SKM-4,sbm+jol*SKM-4,SP^,0);
        FreeMem(SP,Szz);
        If h[il+1,jl+1]<11 then
          Begin
            h[il+1,jl+1]:=h[il+1,jl+1]+1;
            For i:=(il-1) to il do
              For n:=(jl-1) to jl do
                Int_4Ug(i*SKM+sam,n*SKM+sbm,h[i+1,n+1]*KCL+kc,
                       (i+1)*SKM+sam,n*SKM+sbm,h[i+2,n+1]*KCL+kc,
                       i*SKM+sam,(n+1)*SKM+sbm,h[i+1,n+2]*KCL+kc,
		       (i+1)*SKM+sam,(n+1)*SKM+sbm,h[i+2,n+2]*KCL+kc);
          End;
        Line_H(BC,jl+1);
        Szz:=ImageSize(sam+il*SKM-4,sbm+jl*SKM-4,sam+il*SKM+4,sbm+jl*SKM+4);
        GetMem(SP,Szz);
        GetImage(sam+il*SKM-4,sbm+jl*SKM-4,sam+il*SKM+4,sbm+jl*SKM+4,SP^);
        SetLineStyle(0,0,3);
        SetColor(0);
        Circle(sam+il*SKM,sbm+jl*SKM,2);
        SetLineStyle(0,0,1);
        MShow(x,y);
        Delay(70);
      End;
    If (But=2) and (il>=0) and (jl>=0) then
      Begin
        Change:=True;
        MHide(x,y);
        Line_H(0,jol+1);
        PutImage(sam+iol*SKM-4,sbm+jol*SKM-4,SP^,0);
        FreeMem(SP,Szz);
        If h[il+1,jl+1]>-11 then
          Begin
            h[il+1,jl+1]:=h[il+1,jl+1]-1;
            For i:=(il-1) to il do
              For n:=(jl-1) to jl do
                Int_4Ug(i*SKM+sam,n*SKM+sbm,h[i+1,n+1]*KCL+kc,
                       (i+1)*SKM+sam,n*SKM+sbm,h[i+2,n+1]*KCL+kc,
                       i*SKM+sam,(n+1)*SKM+sbm,h[i+1,n+2]*KCL+kc,
		       (i+1)*SKM+sam,(n+1)*SKM+sbm,h[i+2,n+2]*KCL+kc);
          End;
        Line_H(BC,jl+1);
        Szz:=ImageSize(sam+il*SKM-4,sbm+jl*SKM-4,sam+il*SKM+4,sbm+jl*SKM+4);
        GetMem(SP,Szz);
        GetImage(sam+il*SKM-4,sbm+jl*SKM-4,sam+il*SKM+4,sbm+jl*SKM+4,SP^);
        SetLineStyle(0,0,3);
        SetColor(0);
        Circle(sam+il*SKM,sbm+jl*SKM,2);
        SetLineStyle(0,0,1);
        MShow(x,y);
        Delay(70);
      End;
  Until Ch=#27;
  Err:=0;
  MHide(x,y);
End;

Procedure Cmpl_Lab;
Var F1:Text;
    F:File;
    Fl_Ln:array[1..22] of String[30];
    ii,uu:Byte;
Begin
  Assign(f,'labirint.txt');
  {$I-}
  Reset(f);
  Close(f);
  {$I+}
  If IOResult<>0 then
    Begin
      About(Fls_Nm[14]);
      Exit;
    End;
  Reset(f,1);
  s:=FileSize(f);
  If FileSize(f)<>526 then
    begin
      About(Fls_Nm[15]);
      Exit;
    end;
  Close(f);
  assign(f1,'labirint.txt');
  Reset(f1);
  ii:=0;
  Repeat
    Inc(ii);
    If Not(Eof(f1)) then ReadLn(F1,Fl_Ln[ii]);
    If Length(Fl_Ln[ii])<>22 then
      Begin
        About(Fls_Nm[15]);
        Exit;
      End;
  Until (ii=22) or Eof(f1);
  If ii<22 then
    Begin
      About(Fls_Nm[15]);
      Exit;
    End;
  If Change then
    Begin
      About(Fls_Nm[18]);
      Save_l;
    End;
  For ii:=0 to 21 do
    for uu:=0 to 21 do
      Case Fl_Ln[ii+1,uu+1] of
        '0':h[ii,uu]:=3;
        '1':h[ii,uu]:=-1;
        '2':h[ii,uu]:=7;
        '3':h[ii,uu]:=-7;
       Else
         Begin
           About(Fls_Nm[16]);
           Exit;
         End;
      end;
  About(Fls_Nm[17]);
End;

Procedure Draw_PCX(FN:String;x1x,y1y:Integer);
var kp:integer;
    pl:user_pal;
Begin
  ClearDevice;
  fpcx8scr(FN,x1x,y1y,kp,pl);
End;

End.